# -*- coding: utf-8 -*-
import vte, pango
import child, __BASIC__, GConf, Conf, func

class egg (__BASIC__.egg) :

	WIDGET = None

	CHILD_TYPE = child.TYPE_VIM

	ARGUMENT = tuple()
	DIRECTORY = str()
	FORK_COMMAND = str()
	ENVIRONMENT = tuple()

	DEFAULT_FONTNAME = "Bitstream Vera Sans Mono 16"
	EMULATION = "xterm"
	UNIT_FONT_DELM = 1000
	RANGE_FONT_SIZE = (10000, 30000)

	SIGNAL_REMOVE = "child-exited"

	def __init__ (self, **kwargs) :

		if kwargs.has_key("environment") :
			if type(kwargs["environment"]) is not tuple :
				raise TypeError, "The type of environment must be tuple."

			self.ENVIRONMENT = kwargs["environment"]

		if kwargs.has_key("argument") :
			if type(kwargs["argument"]) is not tuple :
				raise TypeError, "The type of argument must be tuple."

			self.ARGUMENT = kwargs["argument"]

		if not kwargs.has_key("command") and not self.FORK_COMMAND :
			raise ValueError, "command argument must be needed."
		elif kwargs.has_key("command") :
			self.FORK_COMMAND = kwargs["command"]

		if kwargs.has_key("directory") :
			if os.path.isdir(kwargs["directory"]) :
				self.DIRECTORY = kwargs["directory"]

		self.GCONF_CLIENT = GConf.Client()

	def reset (self) :
		#self.reset_vte()
		self.WIDGET.reset(True, True)
		#self.WIDGET.feed_child("")
		#self.WIDGET.feed_child("")

	def set_font_from_string (self, fontname) :
		self.WIDGET.set_font_from_string(fontname)
		self.reset()

	def set_font (self, fontDescription) :
		self.WIDGET.set_font(fontDescription)
		self.reset()

	def decrease_font (self, size=int()) :

		pd = self.WIDGET.get_font()

		__s = pd.get_size() - self.UNIT_FONT_DELM
		if __s not in \
				range(self.RANGE_FONT_SIZE[0], self.RANGE_FONT_SIZE[1]) :
			return

		pd.set_size(__s)
		self.WIDGET.set_font(pd)
		self.reset()

		return

	def increase_font (self, size=int()) :

		pd = self.WIDGET.get_font()

		__s = pd.get_size() + self.UNIT_FONT_DELM
		if __s not in \
				range(self.RANGE_FONT_SIZE[0], self.RANGE_FONT_SIZE[1]) :
			return

		pd.set_size(__s)
		self.WIDGET.set_font(pd)
		self.reset()

		return

	def make (self) :
		self.WIDGET = vte.Terminal()

		self.WIDGET.set_audible_bell(False)
		self.WIDGET.set_visible_bell(True)
		self.WIDGET.set_scroll_on_output(False)
		self.WIDGET.set_scrollback_lines(100)
		self.WIDGET.set_mouse_autohide(True)
		self.WIDGET.set_size(10,300)

		self.WIDGET.connect("char-size-changed", self.reset_vte)
		self.reset()
		__pd = pango.FontDescription(self.DEFAULT_FONTNAME)
		self.WIDGET.set_font(__pd)
		self.WIDGET.set_emulation(self.EMULATION)

		argument = (self.FORK_COMMAND, ) + self.ARGUMENT

		self.WIDGET.fork_command( \
			self.FORK_COMMAND, \
			argv=argument, \
			envv=self.ENVIRONMENT, \
			directory=self.DIRECTORY, \
		)

		self.WIDGET.show()
		self.activate_dnd()

	def reset_vte (self, parm1=None, parm2=None, parm3=None) :
		self.WIDGET.set_size(10,10)

	def send (self, command) :
		self.WIDGET.feed_child(command)

	def on_drag_received \
			(self, widget, context, x, y, selection, targetType, time) :

		__path = func.get_filename_from_uri(selection.data)
		self.send(__path)

		return

		if targetType == Conf.DND_TARGET_COLOR :
			pass
		elif targetType == Conf.DND_TARGET_BGIMAGE :
			pass
		elif targetType == Conf.DND_TARGET_RESET_BG :
			pass
		elif targetType == Conf.DND_TARGET_URI_LIST :
			pass
		elif targetType == Conf.DND_TARGET_MOZ_URL :
			pass
		elif targetType == Conf.DND_TARGET_UTF8_STRING :
			pass
		elif targetType == Conf.DND_TARGET_COMPOUND_TEXT :
			pass
		elif targetType == Conf.DND_TARGET_TEXT_PLAIN :
			pass
		elif targetType == Conf.DND_TARGET_STRING :
			pass
		elif targetType == Conf.DND_TARGET_TEXT_PLAIN :
			pass
		elif targetType == Conf.DND_TARGET_TEXT :
			pass
		else :
			pass

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "__VTE__.py"

